"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createFormatterConfiguration = void 0;
const BasicFormatter_1 = require("./BasicFormatter");
const CodeFrameFormatter_1 = require("./CodeFrameFormatter");
function createFormatterConfiguration(options) {
    if (typeof options === 'function') {
        return options;
    }
    const type = options
        ? typeof options === 'object'
            ? options.type || 'codeframe'
            : options
        : 'codeframe';
    if (!type || type === 'basic') {
        return BasicFormatter_1.createBasicFormatter();
    }
    if (type === 'codeframe') {
        const configuration = options && typeof options === 'object'
            ? options.options || {}
            : {};
        return CodeFrameFormatter_1.createCodeFrameFormatter(configuration);
    }
    throw new Error(`Unknown "${type}" formatter. Available types are: "basic", "codeframe" or a custom function.`);
}
exports.createFormatterConfiguration = createFormatterConfiguration;
