import * as webpack from 'webpack';
import { SyncHook, SyncWaterfallHook, AsyncSeriesWaterfallHook } from 'tapable';
import { FilesChange } from '../reporter';
import { Issue } from '../issue';
declare function createForkTsCheckerWebpackPluginHooks(): {
    start: AsyncSeriesWaterfallHook<[FilesChange, webpack.Compilation], import("tapable").UnsetAdditionalOptions>;
    waiting: SyncHook<[webpack.Compilation], void, import("tapable").UnsetAdditionalOptions>;
    canceled: SyncHook<[webpack.Compilation], void, import("tapable").UnsetAdditionalOptions>;
    error: SyncHook<[Error, webpack.Compilation], void, import("tapable").UnsetAdditionalOptions>;
    issues: SyncWaterfallHook<[Issue[], webpack.Compilation | undefined], void>;
};
declare type ForkTsCheckerWebpackPluginHooks = ReturnType<typeof createForkTsCheckerWebpackPluginHooks>;
declare function getForkTsCheckerWebpackPluginHooks(compiler: webpack.Compiler | webpack.MultiCompiler): {
    start: AsyncSeriesWaterfallHook<[FilesChange, webpack.Compilation], import("tapable").UnsetAdditionalOptions>;
    waiting: SyncHook<[webpack.Compilation], void, import("tapable").UnsetAdditionalOptions>;
    canceled: SyncHook<[webpack.Compilation], void, import("tapable").UnsetAdditionalOptions>;
    error: SyncHook<[Error, webpack.Compilation], void, import("tapable").UnsetAdditionalOptions>;
    issues: SyncWaterfallHook<[Issue[], webpack.Compilation | undefined], void>;
};
export { getForkTsCheckerWebpackPluginHooks, ForkTsCheckerWebpackPluginHooks };
